View Issue Details

IDProjectCategoryView StatusLast Update
0002146OpenFOAMPatchpublic2016-07-10 22:06
Reporterwyldckat Assigned Tohenry  
PrioritynormalSeverityminorReproducibilityalways
Status resolvedResolutionfixed 
Product Versiondev 
Fixed in Versiondev 
Summary0002146: Recent transfer of logicistics from AllwmakeParseArguments to wmake, results in 2 pass build
DescriptionRecent commit 276eb1a31bb8f has lead to having a 2 pass build when running scripts from "./Allwmake" scripts that rely on "AllwmakeParseArguments". This is because after "wmake all" is done, it will continue running the original "Allwmake" script.

Attached is the updated file for "wmake/scripts/AllwmakeParseArguments".

The change is very small, simply use "exec" before running "wmake all", which will defer the original "Allwmake" script work-flow to the wmake call, which will in turn take care of running "Allwmake" again.

I didn't use "exit", because I couldn't remember what was the special macro for the error code.
TagsNo tags attached.

Activities

wyldckat

2016-07-10 21:51

updater  

AllwmakeParseArguments (3,300 bytes)   
#----------------------------------*-sh-*--------------------------------------
# =========                 |
# \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
#  \\    /   O peration     |
#   \\  /    A nd           | Copyright (C) 2014-2016 OpenFOAM Foundation
#    \\/     M anipulation  |
#------------------------------------------------------------------------------
# License
#     This file is part of OpenFOAM.
#
#     OpenFOAM is free software: you can redistribute it and/or modify it
#     under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
#     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#     FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#     for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
#
# File
#     wmake/scripts/AllwmakeParseArguments
#
# Description
#     Allwmake argument parser
#
# Usage
#     # Parse the arguments by sourcing this script
#     . $WM_PROJECT_DIR/wmake/scripts/AllwmakeParseArguments
#
#------------------------------------------------------------------------------
Script=${0##*/}

usage() {
    exec 1>&2
    while [ "$#" -ge 1 ]; do echo "$1"; shift; done

    # Print normal usage options
    cat<<USAGE

Usage: $Script [OPTIONS]

Executing $Script is equivalent to

   wmake -all [OPTIONS]
USAGE

    wmake -help
    exit 1
}


#------------------------------------------------------------------------------
# Parse the arguments and options
#------------------------------------------------------------------------------

fromWmake=
qOpt=

for arg in "$@"
do
    # Remove arg
    shift

    case "$arg" in
        -h | -help)
            usage
            exit 0
            ;;
        # Check if called from wmake to avoid recusion
        -fromWmake)
            fromWmake="fromWmake"
            ;;
        -q)
            qOpt="-q"
            # Permanently remove arg
            continue
            ;;
        # Target type
        lib | libo | libso | dep | objects)
            targetType=$arg
            ;;
    esac

    # Re-insert arg
    set -- "$@" "$arg"
done


#------------------------------------------------------------------------------
# Execute wmake -all if not called from wmake
#------------------------------------------------------------------------------

if [ -z "$fromWmake" ]
then
    exec wmake -all $qOpt $*
fi


#------------------------------------------------------------------------------
# If WM_CONTINUE_ON_ERROR not set activate the shell option "stop on error"
#------------------------------------------------------------------------------

if [ -z "${WM_CONTINUE_ON_ERROR}" ]
then
    set -e
fi


#------------------------------------------------------------------------------
# Cleanup local variables and functions
#------------------------------------------------------------------------------

unset Script usage fromWmake


#------------------------------------------------------------------------------
AllwmakeParseArguments (3,300 bytes)   

henry

2016-07-10 22:06

manager   ~0006520

Thanks Bruno.

Resolved by commit b3386623a23a32a6859827e1ca3f48fc5bbdf720

Issue History

Date Modified Username Field Change
2016-07-10 21:51 wyldckat New Issue
2016-07-10 21:51 wyldckat Status new => assigned
2016-07-10 21:51 wyldckat Assigned To => henry
2016-07-10 21:51 wyldckat File Added: AllwmakeParseArguments
2016-07-10 22:06 henry Note Added: 0006520
2016-07-10 22:06 henry Status assigned => resolved
2016-07-10 22:06 henry Fixed in Version => dev
2016-07-10 22:06 henry Resolution open => fixed